/* --------------------------------------------------------------------------

        File Name:              findlibusb.cpp

        findlibusb finds the correct folder for libusb, so that it can be supplied as
        as parameter to the Paylink link


        Copyright:               Aardvark Embedded Solutions Ltd. 2017

   -------------------------------------------------------------------------- */

#include <sys/types.h>
#include <sys/timeb.h>
#include <sys/stat.h>
#include <string.h>
#include <time.h>
#include <fcntl.h>
#include <signal.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <dlfcn.h>
#include <unistd.h>

typedef int int32_t ;
#undef isalpha
#undef isdigit


int main(int ac, char** av)
    {
    void* Handle = dlopen("libusb-1.0.so.0", RTLD_NOW) ;
    if (Handle == 0)
        {
        fprintf(stderr, "**I** can't see libusb !!\n") ;
        }
    else
        {
        typedef struct lmap
          {
          void*    base_address;   /* Base address of the shared object */
          char*    path;           /* Absolute file name (path) of the shared object */
          void*    not_needed1;    /* Pointer to the dynamic section of the shared object */
          struct lmap *next, *prev;/* chain of loaded objects */
          } Lmap ;

        Lmap* Detail = (Lmap*) Handle ;
        char Folder[1000] ;
        strcpy(Folder, Detail->path) ;
        for (int i = strlen(Folder) ; i > 0 ; --i)
          {
          if (Folder[i] == '/')
            {
            Folder[i] = 0 ;
            break ;
            }
          }
        printf("-L%s\n", Folder) ;
        }
    return 1 ;
    }
